﻿'=============================================================================
' QCOM.Designer.vb
'
' Provides the initialization entry points for the program
'
' Copyright (C) 2013 - 2013 Quartzdyne, Inc.  All rights reserved.
'
' Express written permission is hereby granted from Quartzdyne, Inc., to
' copy, modify, reproduce, and transmit this source code in any form and by
' any means, electronic or mechanical, including photocopying, recording, and
' any information storage and retrieval system as needed.  Permission is also
' hereby granted to use this source code in any form and means as needed.
' While every reasonable precaution has been taken in the preparation of this
' source code, Quartzdyne, Inc., assumes no responsibility for errors,
' omissions, or damages from the use of the source code contained herein.
'
' NEITHER QUARTZDYNE, INC., ANY MEMBER OF QUARTZDYNE, INC., NOR ANY PERSON OR
' ORGANIZATION ACTING ON BEHALF OF THEM MAKES ANY WARRANTY OR REPRESENTATION
' WHATSOEVER, EXPRESS OR IMPLIED, INCLUDING ANY WARRANTY OF MERCHANTABILITY
' OR FITNESS FOR ANY PURPOSE WITH RESPECT TO THE SOURCE CODE OR ASSUMES ANY
' LIABILITY WHATSOEVER WITH RESPECT TO ANY USE OF THE SOURCE CODE OR ANY
' PORTION THEREOF OR WITH RESPECT TO ANY DAMAGES THAT MAY RESULT FROM SUCH
' USE.
'
' Noji Ratzlaff
'
' See QCOM.log for a complete history of all updates, changes, and revisions
' of this source and other files and policies regarding QCOM software
'
' Updated 04-23-2013
'=============================================================================
Imports System.Runtime.InteropServices
'-----------------------------------------------------------------------------
' Windows MEMORYSTATUSEX structure
'-----------------------------------------------------------------------------
Public Structure MEMORYSTATUSEX
    Dim Length As UInt32
    Dim MemoryLoad As UInt32
    Dim TotalPhys As UInt64
    Dim AvailPhys As UInt64
    Dim TotalPageFile As UInt64
    Dim AvailPageFile As UInt64
    Dim TotalVirtual As UInt64
    Dim AvailVirtual As UInt64
    Dim AvailExtendedVirtual As UInt64
End Structure                       ' MEMORYSTATUSEX
'-----------------------------------------------------------------------------
' Windows OSVERSIONINFOEX structure
'
' Note: This structure is 156 bytes long because it is being passed to
'       GetVersionExA, which uses the non-wide (128-byte) CSDVersion
'       string
'-----------------------------------------------------------------------------
Public Structure OSVERSIONINFOEX
    Dim OSVersionInfoSize As UInt32
    Dim MajorVersion As UInt32
    Dim MinorVersion As UInt32
    Dim BuildNumber As UInt32
    Dim PlatformId As UInt32
    <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=128)> Dim CSDVersion As String
    Dim ServicePackMajor As UInt16
    Dim ServicePackMinor As UInt16
    Dim SuiteMask As UInt16
    Dim ProductType As Byte
    Dim Reserved As Byte
End Structure                       ' OSVERSIONINFOEX
'-----------------------------------------------------------------------------
' Windows_Imports is the Windows function import module
'-----------------------------------------------------------------------------
Module Windows_Imports

    <DllImport("kernel32.dll", EntryPoint:="CreateMutex", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function CreateMutex(ByVal mutexAttributes As Integer, ByVal inheritHandle As Boolean, ByVal mutexName As String) As IntPtr
        'Intentionally left blank
    End Function
    <DllImport("kernel32.dll", EntryPoint:="GetSystemMetrics", CharSet:=CharSet.Auto, ExactSpelling:=True)>
    Public Function GetSystemMetrics(ByVal index As Integer) As Integer
        'Intentionally left blank
    End Function
    <DllImport("kernel32.dll", EntryPoint:="GetTickCount", CharSet:=CharSet.Auto, ExactSpelling:=True)>
    Public Function GetTickCount() As Integer
        'Intentionally left blank
    End Function
    <DllImport("kernel32.dll", EntryPoint:="GetVersionExA", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function GetVersionExA(ByRef versionInfo As OSVERSIONINFOEX) As Boolean
        'Intentionally left blank
    End Function
    <DllImport("kernel32.dll", EntryPoint:="GlobalMemoryStatusEx", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function GlobalMemoryStatusEx(ByRef memoryStatus As MEMORYSTATUSEX) As <MarshalAs(UnmanagedType.Bool)> Boolean
        'Intentionally left blank
    End Function
    <DllImport("kernel32.dll", EntryPoint:="OpenMutex", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function OpenMutex(ByVal desiredAccess As Integer, ByVal inheritHandle As Boolean, ByVal mutexName As String) As IntPtr
        'Intentionally left blank
    End Function
    <DllImport("kernel32.dll", EntryPoint:="ReleaseMutex", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function ReleaseMutex(ByVal mutexHandle As IntPtr) As Boolean
        'Intentionally left blank
    End Function

End Module                              ' Windows_Imports
'-----------------------------------------------------------------------------
' QCOM_DLL_Imports is the DLL function import module
'-----------------------------------------------------------------------------
Module QCOM_DLL_Imports

    <DllImport("qdUSB.dll", EntryPoint:="QD_CalculatePressureAndTemperature", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_CalculatePressureAndTemperature(ByRef coefficientData As Byte, ByVal pressureCount As UInt32, ByVal temperatureCount As UInt32, ByRef pressurePSI As Double, ByRef temperatureCelsius As Double) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_CalculatePressureOrTemperature", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_CalculatePressureOrTemperature(ByVal PorT As Byte, ByRef coefficientData As Byte, ByVal pressureCount As UInt32, ByVal temperatureCount As UInt32, ByRef result As Double) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_CheckReceiveQueue", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_CheckReceiveQueue(ByVal unitHandle As IntPtr, ByRef numberOfBytesInQueue As UInt32, ByRef queueStatus As UInt32) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_ClearInternalError", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_ClearInternalError(ByVal unitHandle As IntPtr) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_Close", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_Close(ByVal unitHandle As IntPtr) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_CoefficientDataIsValid", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_CoefficientDataIsValid(ByRef coefficientData As Byte) As Boolean
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_CoefficientHexFileDataIsValid", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_CoefficientHexFileDataIsValid(ByRef hexFileData As Byte) As Boolean
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_DataIsInHexFileFormat", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_DataIsInHexFileFormat(ByRef hexFileData As Byte) As Boolean
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_ExecuteI2CCommand", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_ExecuteI2CCommand(ByVal unitHandle As IntPtr, ByRef commandString As Byte, ByRef replyString As Byte) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_FirmwareHexFileDataIsValid", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_FirmwareHexFileDataIsValid(ByRef hexFileData As Byte) As Boolean
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_FlushBuffers", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_FlushBuffers(ByVal unitHandle As IntPtr, ByVal flushTransmitBuffer As Byte, ByVal flushReceiveBuffer As Byte) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_FormatCoefficientHexFileData", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_FormatCoefficientHexFileData(ByRef unformattedData As Byte, ByRef formattedData As Byte) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_GetCadenceTimer", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_GetCadenceTimer(ByVal unitHandle As IntPtr, ByRef cadenceTimerValue As UInt32) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_GetI2CDataRate", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_GetI2CDataRate(ByVal unitHandle As IntPtr, ByRef currentDataRate As Double) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_GetInternalErrorCode", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_GetInternalErrorCode(ByVal unitHandle As IntPtr, ByRef errorCode As UInt32) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_GetMemoryType", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_GetMemoryType(ByVal unitHandle As IntPtr, ByVal device As Byte, ByRef memoryType As Byte) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_GetModuleControlRegister", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_GetModuleControlRegister(ByVal unitHandle As IntPtr, ByRef registerValue As Byte) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_GetModuleFirmwareID", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_GetModuleFirmwareID(ByVal unitHandle As IntPtr, ByRef firmwareID As Byte) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_GetModuleModeSwitchSetting", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_GetModuleModeSwitchSetting(ByVal unitHandle As IntPtr, ByRef modeSwitchSetting As Byte) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_GetModuleSerialNumber", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_GetModuleSerialNumber(ByVal unitNumber As UInt32, ByRef serialNumber As Byte) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_GetModuleStatusRegister", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_GetModuleStatusRegister(ByVal unitHandle As IntPtr, ByRef registerValue As Byte) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_GetNumberOfModules", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_GetNumberOfModules() As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_GetPressureAndTemperature", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_GetPressureAndTemperature(ByVal unitHandle As IntPtr, ByRef coefficientData As Byte, ByRef pressurePSI As Double, ByRef temperatureCelsius As Double) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_GetProductInfo", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_GetProductInfo(ByVal unitNumber As UInt32, ByRef productInfoString As Byte, ByVal item As UInt32) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_GetQDDLLVersion", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_GetQDDLLVersion(ByRef majorVersion As Byte, ByRef minorVersion As Byte, ByRef buildVersion As Byte) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_GetTimeouts", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_GetTimeouts(ByRef readTimeout As UInt32, ByRef writeTimeout As UInt32) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_GetTransducerCounts", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_GetTransducerCounts(ByVal unitHandle As IntPtr, ByRef pressureCount As UInt32, ByRef temperatureCount As UInt32) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_GetTransducerCurrent", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_GetTransducerCurrent(ByVal unitHandle As IntPtr, ByRef transducerCurrent As Double) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_GetTransducerType", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_GetTransducerType(ByVal unitHandle As IntPtr, ByRef transducerType As Byte) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_GetTransducerVoltage", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_GetTransducerVoltage(ByVal unitHandle As IntPtr, ByRef transducerVoltage As Double) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_GetUSBDLLVersion", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_GetUSBDLLVersion(ByRef upperVersion As UInt32, ByRef lowerVersion As UInt32) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_GetUSBDriverVersion", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_GetUSBDriverVersion(ByRef upperVersion As UInt32, ByRef lowerVersion As UInt32) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_HexFileFormatIsValid", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_HexFileFormatIsValid(ByRef hexFileData As Byte) As Boolean
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_Open", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_Open(ByVal unitNumber As UInt32, ByRef unitHandle As IntPtr) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_Read", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_Read(ByVal unitHandle As IntPtr, ByRef readBuffer As Byte, ByVal readBufferSize As UInt32, ByRef bytesRead As UInt32) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_ReadCoefficientDataFromDevice", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_ReadCoefficientDataFromDevice(ByVal unitHandle As IntPtr, ByRef coefficientData As Byte) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_ReadCoefficientDataFromHexFile", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_ReadCoefficientDataFromHexFile(ByRef pathName As Byte, ByRef coefficientData As Byte) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_ReadCoefficientDataFromModulePage", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_ReadCoefficientDataFromModulePage(ByVal unitHandle As IntPtr, ByVal pageNumber As Byte, ByRef coefficientData As Byte) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_ReadCoefficientDataFromSourcePage", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_ReadCoefficientDataFromSourcePage(ByVal unitHandle As IntPtr, ByVal device As Byte, ByVal pageNumber As Byte, ByRef coefficientData As Byte) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_ReadUnitADC", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_ReadUnitADC(ByVal unitHandle As IntPtr, ByVal ADCChannel As Byte, ByRef ADCCount As UInt32) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_ResetModule", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_ResetModule(ByVal unitHandle As IntPtr) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_SetCadenceTimer", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_SetCadenceTimer(ByVal unitHandle As IntPtr, ByVal cadenceTimerValue As UInt32) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_SetFirmwareMode", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_SetFirmwareMode(ByVal unitHandle As IntPtr, ByVal mode As Byte) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_SetI2CDataRate", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_SetI2CDataRate(ByVal unitHandle As IntPtr, ByVal newDataRate As Double) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_SetModuleControlRegister", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_SetModuleControlRegister(ByVal unitHandle As IntPtr, ByVal registerValue As Byte) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_SetTimeouts", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_SetTimeouts(ByVal readTimeout As UInt32, ByVal writeTimeout As UInt32) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_SetTransducerPowerState", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_SetTransducerPowerState(ByVal unitHandle As IntPtr, ByVal powerState As Byte) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_Write", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_Write(ByVal unitHandle As IntPtr, ByRef writeBuffer As Byte, ByVal writeBufferSize As UInt32, ByRef bytesWritten As UInt32) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_WriteCoefficientDataToDevice", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_WriteCoefficientDataToDevice(ByVal unitHandle As IntPtr, ByRef coefficientData As Byte) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_WriteCoefficientDataToHexFile", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_WriteCoefficientDataToHexFile(ByRef coefficientData As Byte, ByRef pathName As Byte) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_WriteCoefficientDataToModulePage", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_WriteCoefficientDataToModulePage(ByVal unitHandle As IntPtr, ByVal pageNumber As Byte, ByRef coefficientData As Byte) As UInt32
        'Intentionally left blank
    End Function
    <DllImport("qdUSB.dll", EntryPoint:="QD_WriteCoefficientDataToTargetPage", SetLastError:=True, CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=CallingConvention.Cdecl)>
    Public Function QD_WriteCoefficientDataToTargetPage(ByVal unitHandle As IntPtr, ByVal device As Byte, ByVal pageNumber As Byte, ByRef coefficientData As Byte) As UInt32
        'Intentionally left blank
    End Function

End Module                              ' QCOM_DLL_Imports
'-----------------------------------------------------------------------------
' QCOM_Form
'
' Run the entire program from a single Form class
'-----------------------------------------------------------------------------
<Global.Microsoft.VisualBasic.CompilerServices.DesignerGenerated()> _
Partial Class QCOM_Form
    Inherits Form
    '-------------------------------------------------------------------------
    ' Version strings
    '
    ' Note:     Be sure to edit AssemblyInfo.vb to propogate changes in the
    '           the QCOM software version to the file system
    '-------------------------------------------------------------------------
    Const QCOM_PROGRAM_VERSION_MAJOR As String = "2"
    Const QCOM_PROGRAM_VERSION_MINOR As String = "0"
    Const QCOM_PROGRAM_VERSION_BUILD As String = "0"
    Const QCOM_PROGRAM_VERSION_REV As String = "0"
    Const QCOM_PROGRAM_VERSION_STRING As String = QCOM_PROGRAM_VERSION_MAJOR + "." + QCOM_PROGRAM_VERSION_MINOR + "." + QCOM_PROGRAM_VERSION_BUILD + "." + QCOM_PROGRAM_VERSION_REV
    Const QCOM_PROGRAM_VER_STRING As String = QCOM_PROGRAM_VERSION_MAJOR + "." + QCOM_PROGRAM_VERSION_MINOR + "." + QCOM_PROGRAM_VERSION_BUILD
    '-------------------------------------------------------------------------
    ' Window component dimensions
    '-------------------------------------------------------------------------
    Const GUI_HOME_WINDOW_MIN_WIDTH_WITHOUT_SCROLL As Integer = 940
    Const GUI_HOME_WINDOW_MIN_WIDTH As Integer = GUI_HOME_WINDOW_MIN_WIDTH_WITHOUT_SCROLL
    Const GUI_HOME_WINDOW_MIN_HEIGHT As Integer = 180
    Const GUI_MISC_WINDOW_WIDTH As Integer = 780
    Const GUI_MISC_WINDOW_HEIGHT As Integer = 488
    Const GUI_PROG_INFO_WINDOW_WIDTH As Integer = 800
    Const GUI_PROG_INFO_WINDOW_HEIGHT As Integer = 374
    Const GUI_GENERAL_GROUP_BOX_HEIGHT As Integer = 170
    Const GUI_UNIT_GROUP_BOX_HEIGHT As Integer = 164
    Const GUI_DEFAULT_GROUP_BOX_WIDTH As Integer = GUI_HOME_WINDOW_MIN_WIDTH_WITHOUT_SCROLL - 220
    Const GUI_DEFAULT_BUTTON_WIDTH As Integer = 122
    Const GUI_CLOSE_BUTTON_WIDTH As Integer = 75
    Const GUI_REGULAR_BUTTON_WIDTH As Integer = 70
    Const GUI_GET_SET_BUTTON_WIDTH As Integer = 32
    Const GUI_REGULAR_BUTTON_HEIGHT As Integer = 25
    Const GUI_REGULAR_LABEL_HEIGHT As Integer = 14
    Const GUI_INFO_LABEL_HEIGHT As Integer = 16
    Const GUI_LARGE_LABEL_HEIGHT As Integer = 20
    Const GUI_REGULAR_TEXT_BOX_WIDTH As Integer = 90
    Const GUI_REGULAR_TEXT_BOX_HEIGHT As Integer = 20
    Const GUI_SMALL_TEXT_BOX_HEIGHT As Integer = 16
    Const GUI_REGULAR_CHECK_BOX_HEIGHT As Integer = 16
    Const GUI_REGULAR_COMBO_BOX_HEIGHT As Integer = GUI_REGULAR_TEXT_BOX_HEIGHT
    Const GUI_PROG_INFO_GROUP_BOX_HEIGHT As Integer = 150
    '-------------------------------------------------------------------------
    ' qdUSB definitions
    '-------------------------------------------------------------------------
    Const QD_QUARTZDYNE_ID As Byte = &HD
    Const QD_DEVICE_TRANSDUCER As Byte = 0
    Const QD_DEVICE_MODULE As Byte = 1
    Const QD_RETURN_PID As UInt32 = 4
    Const QD_COEFFICIENT_DATA_SIZE As UInt32 = 256
    Const QD_MAXIMUM_PRODUCT_STRING_SIZE As UInt32 = 256
    Const QD_MAXIMUM_SERIAL_NUMBER_SIZE As UInt32 = QD_MAXIMUM_PRODUCT_STRING_SIZE
    Const QD_SET_APPLICATION_MODE As Byte = 0
    Const QD_SET_BOOT_LOADER_MODE As Byte = 1
    Const QD_MINIMUM_BOOT_LOADER_MODE_WAIT_TIME As UInt32 = 1500
    Const QD_MAXIMUM_I2C_DATA_RATE As Double = 100.0
    Const QD_TRANSDUCER_TYPE_ABSENT As Byte = 0
    Const QD_TRANSDUCER_TYPE_FREQUENCY As Byte = 1
    Const QD_TRANSDUCER_TYPE_DIGITAL_NOMEM As Byte = 5
    Const QD_TRANSDUCER_CHIP_ID_LENGTH As Byte = 4
    Const QD_SREG_TRANSDUCER_TYPE_MASK As UInt32 = &H7
    Const QD_SREG_TRANSDUCER_PRESENT As UInt32 = &H8
    Const QD_SREG_TRANSDUCER_POWER_STATE As UInt32 = &H20
    Const QD_DISABLE_TRANSDUCER_POWER As Byte = 0
    Const QD_ENABLE_TRANSDUCER_POWER As Byte = 1
    Const QD_FIRMWARE_ID_LENGTH As Byte = 4
    Const QD_FIRMWARE_QUARTZDYNE_ID As Byte = QD_QUARTZDYNE_ID
    Const QD_FIRMWARE_QCOM_ID As Byte = &H16
    Const QD_NUMBER_OF_LOWER_QMEM_PAGES As Byte = 4
    Const QD_MEMORY_TYPE_ABSENT As Byte = 0
    Const QD_MEMORY_TYPE_FRAM As Byte = 1
    Const QD_MEMORY_TYPE_EEPROM As Byte = 2
    Const QD_MINIMUM_CADENCE_TIMER_MS As UInt32 = 250
    Const QD_MAXIMUM_CADENCE_TIMER_MS As UInt32 = 2000
    Const QD_MAXIMUM_TRANSFER_SIZE As Integer = 768
    '-------------------------------------------------------------------------
    ' Integer definitions
    '-------------------------------------------------------------------------
    Const QCOM_MAXIMUM_NUMBER_OF_UNITS As UInt32 = 4
    Const QCOM_TIMEOUT_500MS As UInt32 = 500
    Const QCOM_ONE_SECOND_INTERVAL As Integer = 1000
    Const QCOM_MAXIMUM_SAMPLING_INTERVAL As Integer = 30000
    Const QCOM_MINIMUM_SAMPLING_INTERVAL As Integer = 2
    Const QCOM_DEFAULT_SAMPLING_INTERVAL As Integer = 500
    Const QCOM_DROP_DOWN_CLOSED As Integer = &H10000
    Const QCOM_DROP_DOWN_OPENED As Integer = &H20000
    Const QCOM_DROP_DOWN_DISPLAY_MASK As Integer = &HFFFF0000
    Const QCOM_DROP_DOWN_VERTICAL_POSITION_MASK As Integer = &HFFFF
    Const QCOM_MAXIMUM_I2C_COMMAND_STRING_SIZE As Integer = QD_MAXIMUM_TRANSFER_SIZE
    Const QCOM_MAXIMUM_I2C_REPLY_STRING_SIZE As Integer = QD_MAXIMUM_TRANSFER_SIZE
    Const QCOM_MINIMUM_QDUSB_DLL_MAJOR_VERSION As Byte = 1
    Const QCOM_MINIMUM_QDUSB_DLL_MINOR_VERSION As Byte = 0
    Const QCOM_MINIMUM_QDUSB_DLL_BUILD_VERSION As Byte = 6
    '-------------------------------------------------------------------------
    ' System definitions
    '-------------------------------------------------------------------------
    Const INVALID_HANDLE_VALUE As Integer = -1
    Const SYNCHRONIZE As Integer = &H100000
    Const EALREADY As Integer = 114
    Const VER_NT_WORKSTATION As Integer = &H1
    Const SM_SERVERR2 As Integer = 89
    Const HKEY_LOCAL_MACHINE As Long = &H80000001
    Const KEY_QUERY_VALUE As Long = &H1
    '-------------------------------------------------------------------------
    ' Boolean definitions
    '-------------------------------------------------------------------------
    Const QCOM_PLEASE_WAIT_INSTALL As Boolean = True
    '-------------------------------------------------------------------------
    ' Floating-point definitions
    '-------------------------------------------------------------------------
    Const QCOM_FREQUENCY_MULTIPLIER As Double = 0.0016763806343078613
    '-------------------------------------------------------------------------
    ' Unit flags
    '-------------------------------------------------------------------------
    Const QCOM_UNIT_ZERO_FLAG As UInt32 = 0
    Const QCOM_UNIT_VALID As UInt32 = &H1
    Const QCOM_UNIT_ALLOCATED As UInt32 = &H2
    Const QCOM_UNIT_MODULE_SN_VALID As UInt32 = &H4
    Const QCOM_UNIT_OPEN As UInt32 = &H8
    Const QCOM_UNIT_CONFIG_INFO_LOADED As UInt32 = &H10
    Const QCOM_UNIT_REGISTRY_CHECKED As UInt32 = &H20
    Const QCOM_UNIT_FIRMWARE_ID_PRESENT As UInt32 = &H40
    Const QCOM_UNIT_CAN_COMMUNICATE As UInt32 = &H80
    Const QCOM_UNIT_INITIAL_SETTINGS_SET As UInt32 = &H100
    Const QCOM_UNIT_TRANSDUCER_PRESENT As UInt32 = &H200
    Const QCOM_UNIT_TRANSDUCER_SN_VALID As UInt32 = &H400
    Const QCOM_UNIT_INCLUDE_IN_SAMPLING As UInt32 = &H800
    Const QCOM_UNIT_COEFFICIENT_FILE_SPECIFIED As UInt32 = &H1000
    Const QCOM_UNIT_COEFFICIENTS_VERIFIED As UInt32 = &H2000
    Const QCOM_UNIT_INITIAL_READINGS As UInt32 = &H4000
    Const QCOM_UNIT_OK_TO_SAMPLE As UInt32 = &H8000
    Const QCOM_UNIT_DISPLAY_COUNTS As UInt32 = &H10000
    Const QCOM_UNIT_DISPLAY_COUNTS_IN_HEX As UInt32 = &H20000
    Const QCOM_UNIT_DISPLAY_ALT_UNITS As UInt32 = &H40000
    Const QCOM_UNIT_DISPLAY_FREQUENCIES As UInt32 = &H80000
    Const QCOM_UNIT_DISPLAY_VI_VALUES As UInt32 = &H100000
    Const QCOM_UNIT_BOOT_LOADER_MODE As UInt32 = &H200000
    Const QCOM_UNIT_FIRMWARE_UPDATING As UInt32 = &H400000
    Const QCOM_UNIT_FIRMWARE_UPDATED As UInt32 = &H800000
    Const QCOM_UNIT_SEND_TEXT_XD_READINGS As UInt32 = &H1000000
    Const QCOM_UNIT_SEND_EMAIL_XD_READINGS As UInt32 = &H2000000
    Const QCOM_UNIT_SEND_TEXT_ERROR_MESSAGES As UInt32 = &H4000000
    Const QCOM_UNIT_SEND_EMAIL_ERROR_MESSAGES As UInt32 = &H8000000
    Const QCOM_UNIT_CURRENTLY_SAMPLING As UInt32 = &H10000000
    Const QCOM_UNIT_SEND_XD_READINGS As UInt32 = &H20000000
    Const QCOM_UNIT_TRANSDUCER_POWER_ENABLED As UInt32 = &H40000000
    Const QCOM_UNIT_DEFAULT_SETTINGS As UInt32 = QCOM_UNIT_INCLUDE_IN_SAMPLING
    Const QCOM_UNIT_INITIAL_SETTINGS As UInt32 = QCOM_UNIT_DEFAULT_SETTINGS
    Const QCOM_UNIT_DEFAULT_PERSISTENT_FLAGS As UInt32 = _
        (QCOM_UNIT_DISPLAY_COUNTS Or _
         QCOM_UNIT_DISPLAY_COUNTS_IN_HEX Or _
         QCOM_UNIT_DISPLAY_ALT_UNITS Or _
         QCOM_UNIT_DISPLAY_FREQUENCIES Or _
         QCOM_UNIT_DISPLAY_VI_VALUES)
    Const QCOM_UNIT_READY As UInt32 = _
        (QCOM_UNIT_VALID Or _
         QCOM_UNIT_OPEN Or _
         QCOM_UNIT_OK_TO_SAMPLE Or _
         QCOM_UNIT_TRANSDUCER_POWER_ENABLED)
    '-------------------------------------------------------------------------
    ' General Information flags
    '-------------------------------------------------------------------------
    Const QCOM_GENERAL_ZERO_FLAG As UInt32 = &H0
    Const QCOM_GENERAL_ALLOCATED As UInt32 = &H1
    Const QCOM_GENERAL_USB_DRIVER_AVAILABLE As UInt32 = &H2
    Const QCOM_GENERAL_USB_DLL_AVAILABLE As UInt32 = &H4
    Const QCOM_GENERAL_USE_PATH_SPECIFIED As UInt32 = &H8
    Const QCOM_GENERAL_STATUS_LINE_AVAILABLE As UInt32 = &H10
    Const QCOM_GENERAL_EVENT_LOG_SPECIFIED As UInt32 = &H20
    Const QCOM_GENERAL_CURRENTLY_SAMPLING As UInt32 = &H40
    Const QCOM_GENERAL_SAMPLING_TIME_LIMITED As UInt32 = &H80
    Const QCOM_GENERAL_GUI_READY_FOR_UPDATING As UInt32 = &H100
    Const QCOM_GENERAL_GUI_UP_AND_RUNNING As UInt32 = &H200
    Const QCOM_GENERAL_PROGRAM_TIMER_RUNNING As UInt32 = &H400
    Const QCOM_GENERAL_COMMAND_LINE_ONLY As UInt32 = &H800
    Const QCOM_GENERAL_SOUNDS_ENABLED As UInt32 = &H1000
    Const QCOM_GENERAL_INCLUDE_ALL_IN_SAMPLING As UInt32 = &H2000
    Const QCOM_GENERAL_ERROR_LOG_SPECIFIED As UInt32 = &H4000
    Const QCOM_GENERAL_INTERNET_AVAILABLE As UInt32 = &H10000
    Const QCOM_GENERAL_DISPLAY_COUNTS As UInt32 = &H20000
    Const QCOM_GENERAL_DISPLAY_COUNTS_IN_HEX As UInt32 = &H40000
    Const QCOM_GENERAL_DISPLAY_ALT_UNITS As UInt32 = &H80000
    Const QCOM_GENERAL_DISPLAY_ALL_FREQUENCIES As UInt32 = &H100000
    Const QCOM_GENERAL_DISPLAY_ALL_VI_VALUES As UInt32 = &H200000
    Const QCOM_GENERAL_FIRMWARE_UPDATING As UInt32 = &H400000
    Const QCOM_GENERAL_CONFIG_DONT_LOAD As UInt32 = &H800000
    Const QCOM_GENERAL_CONFIG_FILE_SPECIFIED As UInt32 = &H1000000
    Const QCOM_GENERAL_CONFIG_INFO_LOADED As UInt32 = &H2000000
    Const QCOM_GENERAL_CONFIG_DONT_SAVE As UInt32 = &H4000000
    Const QCOM_GENERAL_CONFIG_DELETE_ON_EXIT As UInt32 = &H8000000
    Const QCOM_GENERAL_PROGRAM_PAUSED As UInt32 = &H10000000
    Const QCOM_GENERAL_PROGRAM_EXITING As UInt32 = &H20000000
    Const QCOM_GENERAL_EXPERT_MODE As UInt32 = &H40000000
    Const QCOM_GENERAL_DEFAULT_SETTINGS As UInt32 = QCOM_GENERAL_SOUNDS_ENABLED
    Const QCOM_GENERAL_INITIAL_SETTINGS As UInt32 = QCOM_GENERAL_DEFAULT_SETTINGS
    Const QCOM_GENERAL_DEFAULT_PERSISTENT_FLAGS As UInt32 = _
        (QCOM_GENERAL_SOUNDS_ENABLED Or _
         QCOM_GENERAL_DISPLAY_COUNTS Or _
         QCOM_GENERAL_DISPLAY_COUNTS_IN_HEX Or _
         QCOM_GENERAL_DISPLAY_ALT_UNITS Or _
         QCOM_GENERAL_DISPLAY_ALL_FREQUENCIES Or _
         QCOM_GENERAL_DISPLAY_ALL_VI_VALUES Or _
         QCOM_GENERAL_EXPERT_MODE)
    '-------------------------------------------------------------------------
    ' Status and results
    '-------------------------------------------------------------------------
    Const QCOM_SUCCESS As UInt32 = &H0
    Const QCOM_FAILURE As UInt32 = &H7FFFFFFF
    Const QCOM_ERROR_NO_ERROR As UInt32 = &H0
    Const QCOM_ERROR_INVALID_HANDLE As UInt32 = &H1
    Const QCOM_ERROR_INVALID_PARAMETER As UInt32 = &H6
    Const QCOM_ERROR_MEMORY_ALLOCATION_FAILED As UInt32 = &H14
    Const QCOM_ERROR_FILE_OPEN_FAILURE As UInt32 = &H15
    Const QCOM_ERROR_UNIT_NOT_READY As UInt32 = &H1B
    Const QCOM_ERROR_UNREACHABLE_CONDITION As UInt32 = &H29
    Const QCOM_ERROR_NULL_POINTER_PARAMETER As UInt32 = &H2A
    Const QCOM_ERROR_ZERO_LENGTH_STRING_PARAMETER As UInt32 = &H2B
    Const QCOM_ERROR_INVALID_STRING_PARAMETER As UInt32 = &H2C
    Const QCOM_ERROR_INVALID_COEFFICIENT_DATA As UInt32 = &H40
    Const QCOM_ERROR_GENERAL_STRUCTURE_INVALID As UInt32 = &H60
    Const QCOM_ERROR_FILE_NOT_FOUND As UInt32 = &H70
    Const QCOM_ERROR_INVALID_FILE_NAME As UInt32 = &H71
    Const QCOM_ERROR_INVALID_FILE_FOUND As UInt32 = &H72
    Const QCOM_ERROR_UNABLE_TO_CREATE_FILE As UInt32 = &H73
    Const QCOM_ERROR_UNABLE_TO_READ_FILE As UInt32 = &H74
    Const QCOM_ERROR_UNRECOGNIZED_FILE_TYPE As UInt32 = &H77
    Const QCOM_ERROR_BASE_DIRECTORY_NOT_FOUND As UInt32 = &H80
    Const QCOM_ERROR_UNABLE_TO_CREATE_DIRECTORY As UInt32 = &H81
    Const QCOM_ERROR_UNIT_OPEN_FAILURE As UInt32 = &HB0
    Const QCOM_ERROR_INVALID_UNIT_NUMBER As UInt32 = &HB1
    Const QCOM_ERROR_INVALID_MODULE_SN As UInt32 = &HB2
    Const QCOM_ERROR_INVALID_TRANSDUCER_SN As UInt32 = &HB3
    '-------------------------------------------------------------------------
    ' String definitions
    '-------------------------------------------------------------------------
    Const QCOM_PROGRAM_TITLE As String = "QCOM (Quartzdyne Transducer Communication)"
    Const QCOM_PROGRAM_AUTHOR As String = "Noji Ratzlaff (noji@quartzdyne.com)"
    Const QCOM_VENDOR_ID_STRING As String = "10C4"
    Const QCOM_PRODUCT_ID_STRING As String = "85D1"
    Const QUARTZDYNE_URL As String = "http://www.quartzdyne.com/"
    Const QCOM_HELP_URL As String = "http://qd.quartzdyne.com/public/QCOM/QCOM-Help.php"
    Const QCOM_LOG_DIRECTORY As String = "QLog"
    Const QCOM_MUTEX_STRING As String = "QCOMRunning"
    Const QCOM_BLM_ENTER_STRING As String = "Enter Boot Loader Mode"
    Const QCOM_BLM_RESET_STRING As String = "Reset Boot Loader Mode"
    Const QCOM_XD_POWER_ENABLE_STRING As String = "Enable Transducer Power"
    Const QCOM_XD_POWER_DISABLE_STRING As String = "Disable Transducer Power"
    Const QCOM_ENABLE_CONFIG_SAVE_STRING As String = "Save Config File on Exit"
    Const QCOM_DISABLE_CONFIG_SAVE_STRING As String = "Don't Save Config File on Exit"
    Const QCOM_STRING_LF As String = "\n"
    Const QCOM_STRING_ABSENT As String = "Absent"
    Const QCOM_STRING_INVALID As String = "Invalid"
    Const QCOM_STRING_NA As String = "N/A"
    Const QCOM_STRING_NONE As String = "None"
    Const QCOM_STRING_UNAVAILABLE As String = "Unavailable"
    Const QCOM_STRING_UNKNOWN As String = "Unknown"
    Const QCOM_STRING_UNSUPPORTED As String = "Unsupported"
    '-------------------------------------------------------------------------
    ' Graphic files
    '-------------------------------------------------------------------------
    Dim QCOM_PROGRAM_ICON As String = Application.StartupPath + "\QCOM.ico"
    Dim QCOM_PROGRAM_LOGO As String = Application.StartupPath + "\QCOM.png"
    Dim QCOM_BG_GREEN_MARBLE As String = Application.StartupPath + "\QCOM-BG-GreenMarble.jpg"
    Dim QCOM_BG_TOOLSTRIP As String = Application.StartupPath + "\QCOM-BG-OrangeGradient.png"
    Dim QCOM_BG_WHITE_MARBLE As String = Application.StartupPath + "\QCOM-BG-WhiteMarble.gif"
    Dim QCOM_BG_WHITE_SAND As String = Application.StartupPath + "\QCOM-BG-WhiteSand.jpg"
    Dim QCOM_SOUND_ERROR As String = Application.StartupPath + "\QCOM-Error.wav"
    '-------------------------------------------------------------------------
    ' Unit information structure
    '-------------------------------------------------------------------------
    Public Structure UnitInfo
        '---------------------------------------------------------------------
        ' Applicable to the unit instance
        '---------------------------------------------------------------------
        Dim unitNumber As UInt32
        Dim physicalUnitNumber As UInt32
        Dim unitHandle As IntPtr
        Dim moduleSerialNumber As String
        Dim unitDescriptionString As String
        Dim flags As UInt32
        Dim stateFlags As UInt32
        Dim unitSize As UInt32
        Dim moduleMemorySize As Long
        Dim numberOfModuleMemoryPages As Integer
        Dim dataRate As Double
        '---------------------------------------------------------------------
        ' Unit firmware
        '---------------------------------------------------------------------
        Dim firmwareID As Array
        Dim firmwareString As String
        '---------------------------------------------------------------------
        ' Attached transducer
        '---------------------------------------------------------------------
        Dim transducerType As Byte
        Dim transducerSerialNumber As String
        Dim transducerPartNumber As String
        Dim transducerChipID As Array
        Dim transducerMemorySize As Long
        Dim numberOfTransducerMemoryPages As Integer
        Dim pressureCount As Long
        Dim temperatureCount As Long
        Dim pressureValuePSI As Double
        Dim temperatureValueCelsius As Double
        Dim transducerVoltage As Double
        Dim transducerCurrent As Double
        Dim coefficientFilePath As String
        Dim coefficientData As Array
    End Structure                       ' UnitInfo
    '-------------------------------------------------------------------------
    ' General information structure
    '-------------------------------------------------------------------------
    Public Structure GeneralInfo
        Dim numberOfUnits As UInt32
        Dim maximumNumberOfUnits As UInt32
        Dim numberOfTransducers As UInt32
        Dim validUnitBitMap As Integer
        Dim readyUnitBitMap As Integer
        Dim flags As Integer
        Dim stateFlags As Integer
        Dim persistentFlags As Integer
        Dim persistentUnitFlags As Integer
        Dim configFilePath As String
        Dim generalUsePath As String
        Dim logDirectory As String
        Dim windowsVersion As String
        Dim searchString As String
        Dim programStartTime As Integer
        Dim samplingInterval As Integer
        Dim samplingStartTime As Integer
    End Structure                       ' GeneralInfo
    '-------------------------------------------------------------------------
    ' Global objects
    '-------------------------------------------------------------------------
    Private components As System.ComponentModel.IContainer
    Public greenMarbleBackground As Bitmap
    Public whiteSandBackground As Bitmap
    Public whiteMarbleBackground As Bitmap
    Public miscBootLoaderModeButtonArray(QCOM_MAXIMUM_NUMBER_OF_UNITS - 1) As Button
    Public startStopButton As Button
    Public miscTransducerPowerButtonArray(QCOM_MAXIMUM_NUMBER_OF_UNITS - 1) As Button
    Public miscEnableSoundsCheck As CheckBox
    Public miscSendI2CCommandComboArray(QCOM_MAXIMUM_NUMBER_OF_UNITS - 1) As ComboBox
    Public aboutHelpWindow As Form
    Public miscControlsWindow As Form
    Public pleaseWaitWindow As Form
    Public programInfoWindow As Form
    Public QCOM_SoftwareIcon As Drawing.Icon
    Public elapsedTimeLabel As Label
    Public pleaseWaitLabel As Label
    Public errorSound As Media.SoundPlayer
    Public homeStatusStrip As StatusStrip = Nothing
    Public miscTabControl As TabControl
    Public pInfoTabControl As TabControl
    Public miscTabPageArray(QCOM_MAXIMUM_NUMBER_OF_UNITS - 1) As TabPage
    Public pInfoTabPageArray(QCOM_MAXIMUM_NUMBER_OF_UNITS - 1) As TabPage
    Public currentBoxArray(QCOM_MAXIMUM_NUMBER_OF_UNITS - 1) As TextBox
    Public miscI2CResponseBoxArray(QCOM_MAXIMUM_NUMBER_OF_UNITS - 1) As TextBox
    Public miscGetMemoryTypeBoxArray(QCOM_MAXIMUM_NUMBER_OF_UNITS - 1) As TextBox
    Public miscGetModuleFirmwareIDBoxArray(QCOM_MAXIMUM_NUMBER_OF_UNITS - 1) As TextBox
    Public miscGetModuleSerialNumberBoxArray(QCOM_MAXIMUM_NUMBER_OF_UNITS - 1) As TextBox
    Public miscGetSetCadenceTimerBoxArray(QCOM_MAXIMUM_NUMBER_OF_UNITS - 1) As TextBox
    Public miscGetSetControlRegisterBoxArray(QCOM_MAXIMUM_NUMBER_OF_UNITS - 1) As TextBox
    Public miscGetSetI2CDataRateBoxArray(QCOM_MAXIMUM_NUMBER_OF_UNITS - 1) As TextBox
    Public miscGetStatusRegisterBoxArray(QCOM_MAXIMUM_NUMBER_OF_UNITS - 1) As TextBox
    Public miscGetTransducerChipIDBoxArray(QCOM_MAXIMUM_NUMBER_OF_UNITS - 1) As TextBox
    Public miscGetTransducerTypeBoxArray(QCOM_MAXIMUM_NUMBER_OF_UNITS - 1) As TextBox
    Public miscReadTimeoutBox As TextBox
    Public miscWriteTimeoutBox As TextBox
    Public pressureBoxArray(QCOM_MAXIMUM_NUMBER_OF_UNITS - 1) As TextBox
    Public pressureCountBoxArray(QCOM_MAXIMUM_NUMBER_OF_UNITS - 1) As TextBox
    Public pressureFreqBoxArray(QCOM_MAXIMUM_NUMBER_OF_UNITS - 1) As TextBox
    Public samplingIntervalBox As TextBox
    Public temperatureBoxArray(QCOM_MAXIMUM_NUMBER_OF_UNITS - 1) As TextBox
    Public temperatureCountBoxArray(QCOM_MAXIMUM_NUMBER_OF_UNITS - 1) As TextBox
    Public temperatureFreqBoxArray(QCOM_MAXIMUM_NUMBER_OF_UNITS - 1) As TextBox
    Public voltageBoxArray(QCOM_MAXIMUM_NUMBER_OF_UNITS - 1) As TextBox
    Public oneSecondTimer As Windows.Forms.Timer
    Public samplingTimer As Windows.Forms.Timer
    Public configFileTSButton As ToolStripButton
    Public resetModuleTSButton As ToolStripButton
    Public advancedTSDDButton As ToolStripDropDownButton
    Public fileTSDDButton As ToolStripDropDownButton
    Public functionsTSDDButton As ToolStripDropDownButton
    Public helpTSDDButton As ToolStripDropDownButton
    Public homeTSProgressBar As ToolStripProgressBar = Nothing
    Public homeStatusLineTSSLabel As ToolStripStatusLabel
    Public nowStatusLineTSSLabel As ToolStripStatusLabel
    '-------------------------------------------------------------------------
    ' Global custom objects
    '-------------------------------------------------------------------------
    Public QCOM_MonthStringArray As Array
    Public QCOM_GeneralInfo As GeneralInfo
    Public QCOM_UnitInfoArray(QCOM_MAXIMUM_NUMBER_OF_UNITS - 1) As UnitInfo
    '-------------------------------------------------------------------------
    ' New
    '
    ' Entry method
    '-------------------------------------------------------------------------
    Public Sub New()
        InitializeComponent()
        QCOM_Start()
    End Sub                             ' New()
    '-------------------------------------------------------------------------
    ' InitializeComponent
    '
    ' Provided to satisfy the VB requirement
    '-------------------------------------------------------------------------
    <System.Diagnostics.DebuggerStepThrough()> _
    Private Sub InitializeComponent()
        components = New System.ComponentModel.Container
        '---------------------------------------------------------------------
        ' Register the default (unhandled) exception handler before any class
        ' methods are called, to catch all exceptions not already handled
        '---------------------------------------------------------------------
        AddHandler AppDomain.CurrentDomain.UnhandledException, AddressOf QCOM_DefaultExceptionHandler
    End Sub                             ' InitializeComponent()
    '-------------------------------------------------------------------------
    ' Dispose
    '
    ' Overrides the main Form's dispose method, as required by VB
    '-------------------------------------------------------------------------
    <System.Diagnostics.DebuggerNonUserCode()> _
    Protected Overrides Sub Dispose(ByVal disposing As Boolean)
        Try
            If disposing AndAlso components IsNot Nothing Then
                components.Dispose()
            End If
        Finally
            MyBase.Dispose(disposing)
        End Try
    End Sub                             ' Dispose()
End Class                               ' QCOM_Form
'=============================================================================
' End of QCOM.Designer.vb
'=============================================================================
